"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TrimLine = void 0;

var _react = _interopRequireDefault(require("react"));

var _utils = require("../lib/utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var TrimLine = function TrimLine(_ref) {
  var _ref$borderColor = _ref.borderColor,
      borderColor = _ref$borderColor === void 0 ? "red" : _ref$borderColor,
      _ref$borderStyle = _ref.borderStyle,
      borderStyle = _ref$borderStyle === void 0 ? "dashed" : _ref$borderStyle,
      _ref$borderWidth = _ref.borderWidth,
      borderWidth = _ref$borderWidth === void 0 ? 3 : _ref$borderWidth,
      children = _ref.children,
      _ref$display = _ref.display,
      display = _ref$display === void 0 ? false : _ref$display,
      _ref$margin = _ref.margin,
      margin = _ref$margin === void 0 ? (0, _utils.ins)(0.125) : _ref$margin,
      _ref$radius = _ref.radius,
      radius = _ref$radius === void 0 ? (0, _utils.ins)(0.125) : _ref$radius,
      props = _objectWithoutProperties(_ref, ["borderColor", "borderStyle", "borderWidth", "children", "display", "margin", "radius"]);

  return _react.default.createElement("div", _extends({
    style: {
      margin: margin,
      boxSizing: "border-box",
      borderRadius: radius,
      borderStyle: borderStyle,
      borderColor: display ? borderColor : "transparent",
      borderWidth: borderWidth,
      height: "calc(100% - ".concat(margin * 2, "px)"),
      width: "calc(100% - ".concat(margin * 2, "px)")
    }
  }, props), children);
};

exports.TrimLine = TrimLine;